short getSnRxRd( char sn )
{
	word_t val;
	short dt = REGS[ sn ].RX_RD.WORD;

	val.BYTE[ 0 ] = (uchar)(dt >> 8u);
	val.BYTE[ 1 ] = (uchar) dt;

	return	val.WORD;
}

short getSnRxRsr( char sn )
{
	word_t	val, val1;
	short	rsr;

	rsr = REGS[ sn ].RX_RSR.WORD;
	val.BYTE[ 0 ] = (uchar)(rsr >> 8u);
	val.BYTE[ 1 ] = (uchar) rsr;

	do{						/* update check */
		val1.WORD = val.WORD;
		val.BYTE[ 0 ] = (uchar)(rsr >> 8u);
		val.BYTE[ 1 ] = (uchar) rsr;
	} while( val.WORD != val1.WORD );

	return	val.WORD;
}

int	recv(int sockfd, char *pDst, int maxLen)
{
	uchar status;
	int	recLen, ret;
	ret = SOCKET_ERROR;
	recLen = getSnRxRsr(sockfd);						/* recv size */
	if(0 < recLen) {
		if(maxLen < recLen) {
			recLen = maxLen;
		}
		rxPtr = getSnRxRd(sockfd);						/* recv pointer */
		w5100_read_data(sockfd, rxPtr, pDst, recLen);	/* recv */
		rxPtr += recLen;
		setSnRxRd(sockfd, rxPtr);						/* recv pointer update */

		w5100_set_CR(sockfd, Sn_CR_RECV);				/* CR set */
		WAIT_ENDPROCESS(sockfd);						/*  */
		ret = recLen;
	} else {
		status = w5100_read_SR( sockfd );
		if ((status == Sn_SR_LISTEN) || (status == Sn_SR_CLOSED) || (status == Sn_SR_CLOSE_WAIT)) {
      		// The remote end has closed its side of the connection, so this is the eof state
			ret = 0;
		} else {
			// The connection is still up, but there's no data waiting to be read
			ret = -1;
		}
	}
	return ret;
}

void w5100_read_data(char sn, short rxAddr, char *rdBuf, short len)
{
	int remSize;
	int offset = sn * W5100_RX_BUFF_SIZE;
	rxAddr &= (W5100_RX_BUFF_SIZE - 1);					/* recv pointer mask 0x7FF */
	remSize = W5100_RX_BUFF_SIZE - rxAddr;
	if(len > remSize) {
		memcpy(rdBuf, &reg.RX_Memory[rxAddr+offset], remSize);
		memcpy(&rdBuf[remSize], &reg.RX_Memory[offset], len - remSize);
	}
	else {
		memcpy(rdBuf, &reg.RX_Memory[rxAddr+offset], len);
	}
}

